package com.savvion.cache.listener;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.infinispan.notifications.Listener;
import org.infinispan.notifications.cachelistener.annotation.CacheEntryCreated;
import org.infinispan.notifications.cachelistener.annotation.CacheEntryInvalidated;
import org.infinispan.notifications.cachelistener.annotation.CacheEntryModified;
import org.infinispan.notifications.cachelistener.annotation.CacheEntryRemoved;
import org.infinispan.notifications.cachelistener.annotation.CacheEntryVisited;
import org.infinispan.notifications.cachelistener.annotation.TransactionCompleted;
import org.infinispan.notifications.cachelistener.annotation.TransactionRegistered;
import org.infinispan.notifications.cachelistener.event.CacheEntryCreatedEvent;
import org.infinispan.notifications.cachelistener.event.CacheEntryInvalidatedEvent;
import org.infinispan.notifications.cachelistener.event.CacheEntryModifiedEvent;
import org.infinispan.notifications.cachelistener.event.CacheEntryRemovedEvent;
import org.infinispan.notifications.cachelistener.event.CacheEntryVisitedEvent;
import org.infinispan.notifications.cachelistener.event.TransactionalEvent;
import org.infinispan.util.logging.Log;
import org.infinispan.util.logging.LogFactory;

import com.savvion.cache.test.Test;

@Listener
public class CacheListener {
    Log log = LogFactory.getLog(getClass());
    
    @CacheEntryCreated
    public void cacheEntryCreated(CacheEntryCreatedEvent<?, ?> e) {
        //if (e.isPre() == false) {
            System.out.println("\n\t " + getTime()
                    + " | Cache Entry Is Created with the key : "
                    + e.toString() + "\n");
            
            log.info("Cache entry with key {0} added in cache {1}", e.getKey(),
                    e.getCache());
        //}
    }
    
    @CacheEntryModified
    public void cacheEntryModified(CacheEntryModifiedEvent<?, ?> e) {
       // if (e.isPre() == false && e.getValue() != null) {
            System.out.println("\n\t " + getTime() + " | " + e.getCache()
                    + " | Cache Entry Is modified, <k,v> : <" + e.getKey()
                    + "," + e.getValue() + "> \n");
            log.info("Cache entry with key {0} Modified in cache {1}", e
                    .getKey(), e.getCache());
        //}
    }
    
    @CacheEntryVisited
    public void cacheEntryVisited(CacheEntryVisitedEvent<?, ?> e) {
       // if (e.isPre() == false) {
            System.out.println("\n\t " + getTime()
                    + " | Cache Entry Is Visited, <k,v> : <" + e.getKey() + ","
                    + e.getValue() + ">  \n");
            log.info("Cache entry with key {0} visited in cache {1}", e
                    .getKey(), e.getCache());
        //}
    }
    
    @CacheEntryRemoved
    public void cacheEntryRemoved(CacheEntryRemovedEvent<?, ?> e) {
        //if (e.isPre() == false) {
            System.out.println("\n\t " + getTime()
                    + " | Cache Entry Is Removed,  <k,v> : <" + e.getKey()
                    + "," + e.getValue() + "> \n");
            log.info("Cache entry with key {0} removed in cache {1}", e
                    .getKey(), e.getCache());
        //}
    }
    
    @CacheEntryInvalidated
    public void CacheEntryInvalidated(CacheEntryInvalidatedEvent<?, ?> e) {
        
        System.out.println("\n\t " + getTime()
                + " | Cache Entry Is Invalidated,  <k,v> : <" + e.getKey()
                + "," + e.getValue() + "> \n");
        log.info("Cache entry with key {0} invalidated in cache {1}", e
                .getKey(), e.getCache());
        if (!e.isPre()) {
            System.out.println("sjadhns");
            Test.loadCachefromDBOnvalidate(e.getKey().toString());
        }
        
    }
    
    @TransactionRegistered
    public void TransactionRegistered(TransactionalEvent<?, ?> txe) {
        System.out.println("\n\t " + getTime() + " | Transaction event is : <"
                + txe.getType() + "> \n");
        log.info("\n\t " + getTime() + " | Transaction event is : <"
                + txe.getType() + "> ");
    }
    
    @TransactionCompleted
    public void TransactionCompleted(TransactionalEvent<?, ?> txe) {
        System.out.println("\n\t " + getTime() + " | Transaction event is : <"
                + txe.getType() + "> \n");
        log.info("\n\t " + getTime() + " | Transaction event is : <"
                + txe.getType() + "> ");
    }
    
    public static String getTime() {
        long currentTime = System.currentTimeMillis();
        SimpleDateFormat dateFormat = new SimpleDateFormat("hh:mm:ss:S a");
        return (dateFormat.format(new Date(currentTime)));
    }
}
